<?php

if (!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
global $db, $sugar_config;

class Contacts_Logic_Hooks_Stop_Merge_JCCC_ID
{


    public function stop_saving_if_JCCC_exists($bean, $event, $arguments)
    {

        $action = $_REQUEST['action'];
        $jccc_id = null;
        $link_to_record_with_jccc_id = null;

        if ($action == 'SaveMerge') {


            // If main record has JCCC ID record it.
            if(!is_null($bean->constituent_id_c) && $bean->constituent_id_c <> '')
                $jccc_id = $bean->constituent_id_c;

            // Loop through each id that user is trying to merge.
            foreach($_REQUEST['merged_ids'] as $bean_id)
            {
                // Load Bean User is proposing to merge.
                $bean_to_merge = BeanFactory::getBean('Contacts', $bean_id);
                // If bean bring merged has a JCCC ID.
                if($bean_to_merge->constituent_id_c <> '' && !is_null($bean_to_merge->constituent_id_c))
                {
                    // If all previous beans have not had JCCC IDs
                    if(is_null($jccc_id))
                    {
                        // Add JCCC ID to $jccc_id so that it can be compared to other merging records JCCC IDs.
                        $jccc_id = $bean_to_merge->constituent_id_c;
                        $link_to_record_with_jccc_id = "<a href='index.php?module=Contacts&action=DetailView&record=$bean_to_merge->id'>$bean_to_merge->first_name $bean_to_merge->last_name</a>";
                    }
                    // If merging record has a different JCCC ID as last bean.
                    else if($jccc_id <> $bean_to_merge->constituent_id_c)
                    {
                        // Kill process and provide link to original link.
                        $link = "<a href='index.php?module=Contacts&action=DetailView&record=$bean->id'>$bean->first_name $bean->last_name</a>";
                        print_r("Merge Stopped. Two records with different JCCC IDs can not be merged.<BR>$link", true); return;
                    }
                }
            }
            // If the main record doesn't have a JCCC ID,
            if((is_null($bean->constituent_id_c) || $bean->constituent_id_c == '') && !is_null($jccc_id))
                // Stop Merge and direct user to record with JCCC ID.
                print_r("Merge Stopped. Contact record with JCCC ID must be primary. <BR> JCCC ID $jccc_id
 $link_to_record_with_jccc_id", true); return;

        }
    }

}

?>
