<?php

global $db, $sugar_config;

class Lev_Contracts_Logic_Hooks
{

    //set field: contract_id_gen
    public function Set_Contract_ID(&$focus, $action, $args = array())
    {
        
        if(is_null($focus->contract_id_gen) | !isset($focus->contract_id_gen))
        {
            $sql = "select max(contract_id_gen) as lastID from sugarcrm_old.lev_contracts";
            $result = $GLOBALS['db']->query($sql);
            while($row = $GLOBALS['db']->fetchByAssoc($result))
            {
                $focus->contract_id_gen = $row['lastID'] + 1;
            }
        }
    }

    //set field: name
  public function Set_Name(&$focus, $action, $args = array())
  {
    $associated_accountBean = BeanFactory::getBean('Accounts', $focus->accounts_lev_contracts_1accounts_ida);
    $focus->name = $associated_accountBean->name . ' - ' . $focus->contract_id_gen;
  }

    //set field: name
  public function Set_Name_w_Gross_Margin(&$focus, $action, $args = array())
  {
    $associated_accountBean = BeanFactory::getBean('Accounts', $focus->accounts_lev_contracts_1accounts_ida);
    $focus->name = $associated_accountBean->name . ' - ' . $focus->contract_id_gen + '(' .  number_format($focus->gross_margin_c, 2, '.', '') . '%)';
  }

  //set field: contract_amount
  public function Set_Contract_Amount(&$focus, $action, $args = array())
  {

      $sql = <<<SQL
SELECT sum(course.total_client_fee) AS total_client_fee FROM lev_courses course
      LEFT JOIN lev_contracts_lev_courses_c connect ON course.id=connect.lev_contracts_lev_courseslev_courses_idb AND course.deleted=0 AND course.course_status != 'Cancelled'
      LEFT JOIN lev_contracts contract on connect.lev_contracts_lev_courseslev_contracts_ida=contract.id and connect.deleted=0
      WHERE contract.deleted=0 AND contract.id='{$focus->id}'
SQL;
      $result = $GLOBALS['db']->query($sql);
      while ($row = $GLOBALS['db']->fetchByAssoc($result))
      {
        $focus->contract_amount = $row['total_client_fee'];
      }

  }

  //set field: contract_expense
  public function Set_Contract_Expense(&$focus, $action, $args = array())
  {

      $sql = <<<SQL
SELECT sum(course.total_expense) AS total_expense FROM lev_courses course
      LEFT JOIN lev_contracts_lev_courses_c connect ON course.id=connect.lev_contracts_lev_courseslev_courses_idb AND course.deleted=0 AND course.course_status != 'Cancelled'
      LEFT JOIN lev_contracts contract on connect.lev_contracts_lev_courseslev_contracts_ida=contract.id and connect.deleted=0
      WHERE contract.deleted=0 AND contract.id='{$focus->id}'
SQL;
      $result = $GLOBALS['db']->query($sql);
      while ($row = $GLOBALS['db']->fetchByAssoc($result))
      {
        $focus->contract_expense = $row['total_expense'];
      }

  }

  //set field: contract_net
  public function Set_Contract_Net(&$focus, $action, $args = array())
  {

        $focus->contract_net = $focus->contract_amount - $focus->contract_expense;

  }


	  //set field: gross_margin_c
  public function Set_Contract_Gross(&$focus, $action, $args = array())
  {
    if($focus->contract_amount == '' || $focus->contract_amount == 0)
    {
      $focus->gross_margin_c = 0;
    } else {
      $focus->gross_margin_c = $focus->contract_net / $focus->contract_amount * 100;
    }
  }

  //set field: start_day_of_week_c
  public function Set_Start_Day(&$focus, $action, $args = array())
  {
    if (!empty($focus->start_date_c))
    {
      $focus->start_day_of_week_c = date(l, strtotime($focus->start_date_c));
    }
    else
    {
      $focus->start_day_of_week_c = '';
    }
  }

  //set field: end_day_of_week_c
  public function Set_End_Day(&$focus, $action, $args = array())
  {
    if (!empty($focus->end_date_c))
    {
      $focus->end_day_of_week_c = date(l, strtotime($focus->end_date_c));
    }
    else
    {
      $focus->end_day_of_week_c = '';
    }
  }

  //Set field: academic_period_c
  public function Set_Academic_Period(&$focus, $action, $args = array())
  {

      if (!empty($focus->start_date_c))
      {
          //trobinson@levementum.com 10/3 changing date paramaters to strings
        if (date('Y', strtotime($focus->start_date_c)) < '2013')
        {
          if (date('n', strtotime($focus->start_date_c)) < 5)
          {
            $affix = '21';
          }
          else if (date('n', strtotime($focus->start_date_c)) < 9)
          {
            $affix = '25';
          }
          else
          {
            $affix = '29';
          }
        }
        else
        {
          $affix = '00';
        }
        $focus->academic_period_c = date('Y', strtotime($focus->start_date_c)).$affix;
      }

  }



}

?>
